#include "StdAfx.h"
#include "Define.h"
#include "VaxLine.h"

#include "VaxServerREC.h"
#include "VaxCallSession.h"
#include "StoreLine.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CVaxLine::CVaxLine()
{
}

CVaxLine::~CVaxLine()
{
}

//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

void CVaxLine::OnLineRegisterTrying(LPCTSTR sLineName)
{
	CString sStatus = sLineName + CString(" ") + LINE_REG_TRYING;
    CVaxServerREC::m_pVaxREC->GenStatusLog(sStatus);
}

void CVaxLine::OnLineRegisterFailed(LPCTSTR sLineName, LONG nStatusCode, LPCTSTR sReasonPhrase)
{
	CString sStatus = sLineName + CString(" Register Failed: ") + sReasonPhrase;
    CVaxServerREC::m_pVaxREC->GenStatusLog(sStatus);
}

void CVaxLine::OnLineRegisterSuccess(LPCTSTR sLineName)
{
	CString sStatus = sLineName + CString(" ") + LINE_REG_SUCCESS;
    CVaxServerREC::m_pVaxREC->GenStatusLog(sStatus);
}

//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

BOOL CVaxLine::AddLine(LPCTSTR sLineName, LONG nLineType, LPCTSTR sAuthUser, LPCTSTR sAuthPwd, LPCTSTR sServerAddr, LONG nServerPort, LPCTSTR sAudioCodecList, BOOL bRegister)
{
	RemoveLine(sLineName);
	
	if(!CVaxServerREC::m_pVaxREC->IsInitialized() || CString(sLineName).IsEmpty())
		return FALSE;

	BOOL bResult = CVaxServerREC::m_pVaxREC->AddLine(sLineName, nLineType, "", "", sAuthUser, sAuthPwd, "", sServerAddr, nServerPort, sAudioCodecList);
	if(!bResult) return FALSE;
			
	if(bRegister)
		CVaxServerREC::m_pVaxREC->RegisterLine(sLineName, 1800);
			
	CStoreLine::AddLine(sLineName, nLineType, sAuthUser, sAuthPwd, sServerAddr, nServerPort, sAudioCodecList, bRegister);
	return TRUE;
}

void CVaxLine::RemoveLine(LPCTSTR sLineName)
{
	if(!CVaxServerREC::m_pVaxREC->IsInitialized() || CString(sLineName).IsEmpty())
		return;
		    
	CVaxServerREC::m_pVaxREC->RemoveLine(sLineName);
	CStoreLine::RemoveLine(sLineName);
}

//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

void CVaxLine::LoadLine()
{
	if(!CVaxServerREC::m_pVaxREC->IsInitialized())
		return;

	CStringList objListLine;
	CStoreLine::GetLineNameAll(objListLine);

	if(objListLine.IsEmpty())
		return;

	CString sLineName, sAuthUser, sAuthPwd, sServerAddr, sAudioCodecList;
	
	BOOL bRegister = FALSE;
	LONG nLineType = VAX_LINE_TYPE_UDP, nServerPort = SIP_DEFAULT_PORT;
					
	while(!objListLine.IsEmpty())
	{
		sLineName = objListLine.RemoveHead();
				
		CStoreLine::GetLine(sLineName, nLineType, sAuthUser, sAuthPwd, sServerAddr, nServerPort, sAudioCodecList, bRegister);
		AddLine(sLineName, nLineType, sAuthUser, sAuthPwd, sServerAddr, nServerPort, sAudioCodecList, bRegister);
	}
}
