#include "StdAfx.h"
#include "StoreRegistry.h"
#include "StoreUser.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////

#define SUB_KEY_BUFFER_SIZE		2048
#define USER_ROOT_PATH			"Users\\"

/////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////

BOOL CStoreUser::AddUser(LPCTSTR sUserName, LPCTSTR sPassword, LPCTSTR sAudioCodecList)
{
	if(CString(sUserName).IsEmpty())
		return FALSE;

	CString sKeyPath;
	sKeyPath.Format("%s%s", USER_ROOT_PATH, sUserName);

	CStoreRegistry objStore;

	objStore.SetTEXT(sKeyPath, "UserName", sUserName);
	objStore.SetTEXT(sKeyPath, "Password", sPassword);

	objStore.SetTEXT(sKeyPath, "AudioCodecList", sAudioCodecList);
	
	return TRUE;
}

void CStoreUser::GetUser(LPCTSTR sUserName, CString& sPassword, CString& sAudioCodecList)
{
	CString sKeyPath;
	sKeyPath.Format("%s%s", USER_ROOT_PATH, sUserName);

	CStoreRegistry objStore;
		
	objStore.GetTEXT(sKeyPath, "Password", sPassword, "");
	objStore.GetTEXT(sKeyPath, "AudioCodecList", sAudioCodecList, "");
}

void CStoreUser::RemoveUser(LPCTSTR sUserName )
{
	CString sKeyPath;
	sKeyPath.Format("%s%s", USER_ROOT_PATH, sUserName);

	CStoreRegistry objStore;
	objStore.DeleteSubKey(sKeyPath);
}

void CStoreUser::GetUserAll(CStringList& objList)
{
	objList.RemoveAll();

	CString sKeyPath;
	sKeyPath =  USER_ROOT_PATH;

	CStoreRegistry objStore;
	objStore.EnumSubKeys(sKeyPath, objList);
}

/////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////

BOOL CStoreUser::IsDataStored()
{
	CStoreRegistry objStore;
    return objStore.IsKeyExist(USER_ROOT_PATH);
}
